"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useJunctionProperties = void 0;
/* eslint-disable import/prefer-default-export */
var react_1 = __importDefault(require("react"));
// import { GQPPredicateEditorContext, TGQPPredicateEditorContextType } from "../context";
var context_1 = require("../context");
var useJunctionProperties = function (predicateId) {
    var _a = react_1.default.useContext(context_1.PredicateFormulaEditorContext.context), appendPredicate = _a.appendPredicate, getChildrenIds = _a.getChildrenIds, operatorLabels = _a.operatorLabels, getJunctionById = _a.getJunctionById, getPredicateById = _a.getPredicateById, makeEmptyPredicate = _a.makeEmptyPredicate, isBranchNode = _a.isBranchNode, isRoot = _a.isRoot, removePredicate = _a.removePredicate, setNodeConjunction = _a.setConjunction, setNodeDisjunction = _a.setDisjunction;
    //
    return {
        // queryPredicate:  getJunctionById(nodeId) as TPredicatePropertiesJunction,
        appendPredicate: function (newPredicate) {
            appendPredicate(predicateId, newPredicate);
        },
        getChildrenIds: function () {
            return getChildrenIds(predicateId);
        },
        getPredicateProperties: function () {
            // *tmc* debug
            return getJunctionById(predicateId);
        },
        isBranch: isBranchNode(predicateId),
        isRoot: isRoot(predicateId),
        makeEmptyPredicate: makeEmptyPredicate,
        operatorLabels: operatorLabels,
        removeMe: function () {
            removePredicate(predicateId);
        },
        removePredicateJunction: function () {
            removePredicate(predicateId);
        },
        setConjunction: function () {
            // untestable
            // tests gives: "Maximum update depth exceeded"
            // doesn't seem to be an issue when running in dev/prod.
            // not sure why tests do it
            setNodeConjunction(predicateId);
        },
        setDisjunction: function () {
            // untestable
            // tests gives: "Maximum update depth exceeded"
            // doesn't seem to be an issue when running in dev/prod.
            // not sure why tests do it
            setNodeDisjunction(predicateId);
        },
        /// *************************************************
        // getChildrenIds: () => {
        //   return getChildrenIds(predicateId);
        // },
        getChildIdsOf: function (predicateId) {
            return getChildrenIds(predicateId);
        },
        isBranchNode: isBranchNode(predicateId),
        getPredicateById: getPredicateById,
    };
};
exports.useJunctionProperties = useJunctionProperties;
//# sourceMappingURL=useJunctionProperties.js.map