import type { TPredicateProperties, TValidatorResponse, TPredicatePropertiesArrayValue } from "gabby-query-protocol-lib";
/**
 * "NodeId" sometimes referred to as predicateId.
 * The difference is context. Predicates have no ID. Nodes can be ID'd
 * the tree structure. nodeId can uniquely identify a predicate.
 *
 * @param nodeId - key to retrieve node,
 * @returns
 */
export declare const usePredicateProperties: (nodeId: string) => {
    appendPredicate: (newPredicate: TPredicateProperties) => void;
    getLeafIdsAll: () => string[];
    getPredicateLeafProperties: () => {
        subjectProperties: import("gabby-query-protocol-lib/dist/PredicateSubjects/type").TPredicateSubjectWithId;
        predicateProperties: TPredicateProperties | TPredicatePropertiesArrayValue;
    };
    isRoot: boolean;
    makeEmptyPredicate: () => TPredicateProperties;
    operatorLabels: import("../type").TPredicateOperatorLabels;
    queryPredicate: TPredicateProperties;
    removeMe: () => void;
    removeCurrentPredicate: () => void;
    subjectDictionary: import("gabby-query-protocol-lib").IPredicateSubjectDictionary;
    updateMe: (change: TPredicateProperties | TPredicatePropertiesArrayValue) => void;
    validatePredicateProperties: (predicateProperties: TPredicateProperties | TPredicatePropertiesArrayValue) => TValidatorResponse;
};
