"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.usePredicateTreeUtilities = void 0;
/* eslint-disable import/prefer-default-export */
var react_1 = __importDefault(require("react"));
// import { GQPPredicateEditorContext } from "../context";
// import type { TGQPPredicateEditorContextType } from "../context";
var context_1 = require("../context");
var usePredicateTreeUtilities = function () {
    var _a = react_1.default.useContext(context_1.PredicateFormulaEditorContext.context), getPredicateTreeAsJson = _a.getPredicateTreeAsJson, operatorLabels = _a.operatorLabels, subjectDictionary = _a.subjectDictionary;
    return {
        something: function () {
            subjectDictionary.getSubject("a");
            subjectDictionary.getOptionsList("a");
        },
        getPredicateTreeAsJson: getPredicateTreeAsJson,
        getSubjectById: function (subjectId) { return subjectDictionary.getSubject(subjectId); },
        operatorLabels: operatorLabels,
        subjectDictionary: subjectDictionary,
        // helper function to pull valid options given subjectId and operator
        // example usage: getSelectOptions('subjectId', '$anyOf') -> [validOption1, validOption2, ...]
        // returns valid options or empty array if no valid options.
        getSelectOptions: function (subjectId, operator) {
            // TODO - this could be (TPredicateProperties)=>...
            var subject = subjectDictionary.getSubject(subjectId);
            var validOperators = subject.validOperators;
            var operatorOptions = validOperators[operator];
            var optionList = [];
            if (Array.isArray(operatorOptions.optionList)) {
                optionList = operatorOptions.optionList;
            }
            return optionList;
        },
    };
};
exports.usePredicateTreeUtilities = usePredicateTreeUtilities;
//# sourceMappingURL=usePredicateTreeUtilities.js.map