"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useProjectionSubjects = void 0;
var react_1 = __importDefault(require("react"));
// import { GQPProjectionContext, TGQProjectionContextType } from "../context";
var context_1 = require("../context");
var useProjectionSubjects = function () {
    var _a = react_1.default.useContext(context_1.ProjectionContext.context), addProjectionItem = _a.addProjectionItem, getOrderedProjectionList = _a.getOrderedProjectionList, makeDefaultProjectionItem = _a.makeDefaultProjectionItem, projectionEditor = _a.projectionEditor, removeProjectionItem = _a.removeProjectionItem, updateProjectionSubject = _a.updateProjectionSubject;
    return {
        addProjectionItem: addProjectionItem,
        getColumnOrderedProjectionDictionary: getOrderedProjectionList,
        getProjectableSubjectDictionary: function () {
            return projectionEditor.getProjectableSubjectsDictionary();
        },
        getProjectionOrderByProperty: function (propertyName) {
            return projectionEditor.getProjectionOrderByProperty(propertyName);
        },
        getProjectedSubject: function (projectionId) {
            return projectionEditor.getProjectionSubject(projectionId);
        },
        makeDefaultProjectionItem: makeDefaultProjectionItem,
        moveToColumnPosition: function (projectionKey, columnPosition) {
            Object.entries(getOrderedProjectionList()).forEach(function (_a, idx) {
                var key = _a[0], projection = _a[1];
                if (projection.columnOrder >= columnPosition) {
                    projection.columnOrder++;
                }
                else if (projection.columnOrder < columnPosition) {
                    projection.columnOrder--;
                }
            });
            updateProjectionSubject(projectionKey, { columnOrder: columnPosition });
        },
        normalizeIndexes: function () {
            Object.keys(getOrderedProjectionList()).forEach(function (projectionKey, idx) {
                updateProjectionSubject(projectionKey, { columnOrder: idx });
            });
        },
        projectableSubjects: projectionEditor.getProjectableSubjectsDictionary(),
        projectionAsJson: projectionEditor.toJson(),
        getProjectionAsJson: function () {
            return projectionEditor.toJson();
        },
        removeProjectionItem: removeProjectionItem,
        updateSubjectColumnPosition: function (projectionKey, newColumnPosition) {
            updateProjectionSubject(projectionKey, { columnOrder: newColumnPosition });
        },
    };
};
exports.useProjectionSubjects = useProjectionSubjects;
//# sourceMappingURL=useProjectionSubjects.js.map